// Created by Greg Reese on February 15, 2022

#include "FlowJo_Exception.hpp"

#include <cstring>

using namespace FJ;

// linker doesn't like next inline
//inline
FlowJo_Exception::FlowJo_Exception( const char* text )
   : std::exception()
{
   // make sure to check that text is not nullptr before assigning it 
   // to m_text. Otherwise, will get a difficult error to track down!
   if( text )
      m_text = text;
}

// linker doesn't like next inline
//inline
FlowJo_Exception::FlowJo_Exception( const std::string& text )
   : std::exception(), m_text( text )
{}

void FlowJo_Exception::append( const std::string& text, bool add_space )
{
   if( add_space )
      m_text += ' ';
   m_text += text;
}

void FlowJo_Exception::what( const std::string& new_what )
{
   m_text = new_what; 
}

const char* FlowJo_Exception::what() const noexcept
{
   return m_text.c_str(); 
}
