#include "csv.hpp"

#include "flowjo_utilities.hpp"

using namespace std;

bool FJ::read_csv( const std::string& file,
	std::vector< std::vector<std::string> >& lines, bool skip_first_line )
{
	const char* delimiters = ",";

	ifstream in( file.c_str() );
	if( !in )
		return false;

	lines.clear();
	string aLine;
	if( skip_first_line )
		getline( in, aLine );
	while( getline( in, aLine ) )
	{
		vector<string> tokens = FJ::tokenize( aLine, delimiters );

		// trim whitespace
		for( auto& token : tokens )
			token = trim( token );

		lines.push_back( tokens );
	}
	return true;
}

