// Created by Greg Reese on February 15, 2022

#include "flowjo_exceptions.hpp"

#include <sstream>

using namespace std;
using namespace FJ;

Bad_Enum_Int::Bad_Enum_Int( int num, const std::string& enum_name )
   : FlowJo_Exception()
{
   ostringstream out;
   out << num << " is not a valid value of the enum " << enum_name;
   what( out.str() );
}

Bad_Enum_Text::Bad_Enum_Text( const std::string& bad_text,
   const std::string& enum_name )
   : FlowJo_Exception()
{
   ostringstream out;
   out << '\"' << bad_text << '\"'
      << " is not text for the enum " << enum_name;
   what( out.str() );
}

Bad_File_Open::Bad_File_Open( const std::string& text, bool append ) 
   : FlowJo_Exception() 
{
   string temp = append ? "Couldn\'t open file " + text : text;
   what( temp );
};

Bad_XML_Read::Bad_XML_Read( const char* text )
   : FlowJo_Exception( text )
{}

Bad_XML_Read::Bad_XML_Read( int num )
   : FlowJo_Exception( "Can\'t read XML. Error:")
{
   append( to_string(num) ); // adds space before
}

Bad_XML_Read::Bad_XML_Read( const std::string& text, int num,
   bool add_space )
   : FlowJo_Exception( text )
{
   append( to_string( num ), add_space ); // adds space before
}
