#include "utilities.hpp"

#ifdef WINDOWS
#include "Windows.h"
#else
#include <dlfcn.h>
#endif

#include <filesystem>

using namespace std;
using namespace std::filesystem;

std::string FJ::add_file_path( const std::string& file )
{
   auto executablePath = path( GetExecutablePath() );
   executablePath /= file;
   return executablePath.u8string(); // u8string() returns pathname in native format
}

std::string FJ::GetExecutablePath()
{
   string executablePath;
#ifdef WINDOWS
   char path[MAX_PATH];
   if( GetModuleFileNameA( NULL,path,sizeof( path ) ) == 0 ) // path returned includes file name
      throw runtime_error( "Couldn\'t get path of executable" );

   std::filesystem::path temp( path );
   executablePath = temp.parent_path().u8string();
#else
	Dl_info info;
	if (dladdr( (void*)&add_file_path, &info))
	{			//get the path of the shared object that contains the address of this function
		string path=info.dli_fname;
		executablePath = path.substr(0, path.find_last_of("/"));	//the path may include the name of the dylib
	}
	else
		throw runtime_error( "Couldn\'t get path of executable" );
#endif
   //cout << "Executable path: " << executablePath << '\n\n\n';
   return executablePath;
}




